package com.itrycn.tellmenotice;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;

import android.annotation.SuppressLint;
import android.content.ActivityNotFoundException;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.media.AudioManager;
import android.net.Uri;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.provider.Settings;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.itrycn.ta.AccessibilityOperator;
import com.itrycn.ta.OpenAccessibilitySettingHelper;
import com.qmuiteam.qmui.util.QMUIStatusBarHelper;
import com.qmuiteam.qmui.widget.QMUITopBar;
import com.qmuiteam.qmui.widget.QMUITopBarLayout;
import java.util.Calendar;

import butterknife.BindView;
import butterknife.ButterKnife;

public class MainActivity extends AppCompatActivity {
    QMUITopBarLayout mTopBar;
    ScreenListener screenlistener;
    /**
     *
     */
    public static Context mContext;
    private SharedPreferences sharedPreferences;
    @SuppressLint("SetTextI18n")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        sharedPreferences = PreferenceManager.getDefaultSharedPreferences(this);
        // 沉浸式状态栏
        //QMUIStatusBarHelper.translucent(this);
        //初始化状态栏
        setContentView(R.layout.activity_main);
        // 沉浸式状态栏
        QMUIStatusBarHelper.translucent(this);
        //View root = LayoutInflater.from(this).inflate(R.layout.activity_main, null);
        mTopBar =findViewById(R.id.topbar);
        //ButterKnife.bind(this, root);
        initTopBar();
        if(!isNotificationListenersEnabled())
        {
            gotoNotificationAccessSetting(MainActivity.this);
        }
        AccessibilityOperator.getInstance().init(this);
        OpenAccessibilitySettingHelper.jumpToSettingPage(this);
        if (!Settings.canDrawOverlays(this)) {
            Toast.makeText(this,"请授权app的悬浮框权限", Toast.LENGTH_SHORT).show();
            startActivityForResult(new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION, Uri.parse("package:" + getPackageName())), 0);
        }
        Intent intent2 = new Intent(MainActivity.this,NoticeService.class);
        startService(intent2);
        startFloatingButtonService();
        TextView tv=findViewById(R.id.IdState);
        tv.setText("睿元智能管家,你的私人管家。\n" +
                "1.帮你监控系统通知，自动筛选重要通知。\n" +
                "2.不同通知展现不同的提醒界面和声音。\n" +
                "3.支持免打扰功能,深夜自动免打扰。");
        Button btn=findViewById(R.id.BtnStartMon);
        btn.setText("开启游戏模式");
        btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                boolean GameMode=sharedPreferences.getBoolean("GameMode", false);
                if(sharedPreferences.getBoolean("GameMode", false))
                {
                    sharedPreferences.edit().putBoolean("GameMode", false).apply();
                    btn.setText("开启游戏模式");
                }
                else{
                    sharedPreferences.edit().putBoolean("GameMode", true).apply();
                    btn.setText("关闭游戏模式");
                }
                Intent intent = new Intent("com.itrycn.notice.ACTION_SEND_MESSAGE");
                intent.putExtra("mode", "notice");
                intent.putExtra("GameMode", !GameMode);
                sendBroadcast(intent);
            }
        });
        ScreenListener screenlistener = new ScreenListener(this);
        screenlistener.begin(new ScreenListener.ScreenStateListener() {

            @Override
            public void onUserPresent() {
                //Log.e("onUserPresent", "onUserPresent");
            }

            @Override
            public void onScreenOn() {
                //Log.e("onScreenOn", "onScreenOn");
            }

            @Override
            public void onScreenOff() {
                //region 关闭屏幕自动将通知音量调整到最大
                Calendar c = Calendar.getInstance();
                int hour = c.get(Calendar.HOUR_OF_DAY); // 时
                if(hour>=23 || hour<7) {return; } //23点到早上7点,免打扰时间段
                AudioManager audioManager = (AudioManager) MainActivity.this.getSystemService(Context.AUDIO_SERVICE);
                int NoticeVolume= audioManager.getStreamVolume(AudioManager.STREAM_NOTIFICATION);
                int NoticeMaxVolume= audioManager.getStreamMaxVolume(AudioManager.STREAM_NOTIFICATION);
                int NoticeMinVolume= audioManager.getStreamMinVolume(AudioManager.STREAM_NOTIFICATION);
                if(getWifiName().indexOf("当游")>=0) { //当连接到公司wifi
                    if(hour==12 || hour==13)
                    {
                        //audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeMinVolume, AudioManager.FLAG_PLAY_SOUND);
                    }
                    else {
                        //audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeMinVolume+(NoticeMaxVolume-NoticeMinVolume)/2, AudioManager.FLAG_PLAY_SOUND);
                    }
                }
                else {
                    if (NoticeVolume < 100) {
                        //audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeMinVolume+(NoticeMaxVolume-NoticeMinVolume)*3/4, AudioManager.FLAG_PLAY_SOUND);
                    }
                }
                //endregion
                //Log.e("onScreenOff", "onScreenOff");
            }
        });
    }
    /**
     * 获取wifi名称(必须要有GPS定位权限)
     */
    private String getWifiName()
    {
        WifiManager wifiManager = (WifiManager) getApplicationContext().getSystemService(WIFI_SERVICE);
        WifiInfo wifiInfo = wifiManager.getConnectionInfo();
        return wifiInfo.getSSID();
    }
    private void initTopBar() {
        mTopBar.setBackgroundColor(ContextCompat.getColor(this, R.color.app_color_theme_4));
        mTopBar.addRightImageButton(R.drawable.menu,R.id.menu).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //finish();
                overridePendingTransition(R.anim.slide_still, R.anim.slide_out_right);
            }
        });

        //mTopBar.addLeftBackImageButton().setOnClickListener(new View.OnClickListener() {
        //    @Override
        //    public void onClick(View v) {
       //         finish();
       //         overridePendingTransition(R.anim.slide_still, R.anim.slide_out_right);
       //    }
       // });
      mTopBar.setTitle(R.string.app_name);
    }
    @Override
    protected void onStart() {
        if(!AccessibilityOperator.getInstance().isServiceRunning())
        {
            //Toast.makeText(this,"辅助服务没有在运行。", Toast.LENGTH_SHORT).show();
        }
        super.onStart();
    }
    @Override
    protected void onDestroy() {
        screenlistener.unregisterListener();
        super.onDestroy();
    }
    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == 0) {
            if (!Settings.canDrawOverlays(this)) {
                Toast.makeText(this, "授权失败", Toast.LENGTH_SHORT).show();
            } else {
                Toast.makeText(this, "授权成功", Toast.LENGTH_SHORT).show();
            }
        }
    }
    private static final String ENABLED_NOTIFICATION_LISTENERS = "enabled_notification_listeners";
    private boolean isNotificationListenersEnabled () {
        String pkgName = getPackageName();
        final String flat = Settings.Secure.getString(getContentResolver(), ENABLED_NOTIFICATION_LISTENERS);
        if (!TextUtils.isEmpty(flat)) {
            final String[] names = flat.split(":");
            for (int i = 0; i < names.length; i++) {
                final ComponentName cn = ComponentName.unflattenFromString(names[i]);
                if (cn != null) {
                    if (TextUtils.equals(pkgName, cn.getPackageName())) {
                        return true;
                    }
                }
            }
        }
        return false;
    }
    public static boolean gotoNotificationAccessSetting(Context context) {
        try {
            Intent intent = new Intent("android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS");
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
            context.startActivity(intent);
            return true;

        } catch (ActivityNotFoundException e) {//普通情况下找不到的时候需要再特殊处理找一次
            try {
                Intent intent = new Intent();
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                ComponentName cn = new ComponentName("com.android.settings", "com.android.settings.Settings$NotificationAccessSettingsActivity");
                intent.setComponent(cn);
                intent.putExtra(":settings:show_fragment", "NotificationAccessSettings");
                context.startActivity(intent);
                return true;
            } catch (Exception e1) {
                e1.printStackTrace();
            }
            Toast.makeText(context, "对不起，您的手机暂不支持", Toast.LENGTH_SHORT).show();
            e.printStackTrace();
            return false;
        }
    }
    public void startFloatingButtonService() {
            if (NoticeService.isStarted) {
            return;
        }
        if (!Settings.canDrawOverlays(this)) {
            Toast.makeText(this, "当前无权限，请授权", Toast.LENGTH_SHORT);
            startActivityForResult(new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION, Uri.parse("package:" + getPackageName())), 0);
        }
    }

}