package com.itrycn.tellmenotice;

import android.Manifest;
import android.app.Activity;
import android.app.ActivityManager;
import android.app.Application;
import android.app.Notification;
import android.app.PendingIntent;
import android.app.Service;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothProfile;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.graphics.PixelFormat;
import android.graphics.drawable.Icon;
import android.media.AudioAttributes;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.SoundPool;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.os.Bundle;
import android.os.IBinder;
import android.os.Messenger;
import android.os.Vibrator;
import android.preference.PreferenceManager;
import android.provider.Settings;
import android.service.notification.NotificationListenerService;
import android.service.notification.StatusBarNotification;
import android.text.TextUtils;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RemoteViews;
import android.widget.TextView;
import android.widget.Toast;

import androidx.core.app.ActivityCompat;

import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class NoticeService extends NotificationListenerService {
    public static boolean isStarted = false;
    public static String CurPackageName = "";
    private WindowManager windowManager;
    private WindowManager.LayoutParams layoutParams;
    private  boolean gameMode=false;
    private final BroadcastReceiver messageReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            if ("com.itrycn.notice.ACTION_SEND_MESSAGE".equals(intent.getAction())) {
                gameMode = intent.getBooleanExtra("GameMode",false);
                // 处理收到的消息

            }
        }
    };

    @Override
    public void onCreate() {
        super.onCreate();
        isStarted = true;
        IntentFilter filter = new IntentFilter("com.itrycn.notice.ACTION_SEND_MESSAGE");
        registerReceiver(messageReceiver, filter);
        //配置声音类型。
        AudioAttributes.Builder builder = new AudioAttributes.Builder();
        builder.setLegacyStreamType(AudioManager.STREAM_NOTIFICATION);
        builder.setContentType(AudioAttributes.CONTENT_TYPE_MUSIC);

        //配置SoundPool的属性。
        SoundPool.Builder builder2 = new SoundPool.Builder()
                .setMaxStreams(2) //可以同时播放的声音数量
                .setAudioAttributes(builder.build());

        sp = builder2.build();
        MP3_notice = sp.load(this, R.raw.notice, 1);
        MP3_mm = sp.load(this, R.raw.chattip, 1);
        MP3_Ring = sp.load(this, R.raw.ring, 1);
        MP3_kuaidi = sp.load(this, R.raw.kuaidi, 1);
        MP3_Dingding = sp.load(this, R.raw.dingding, 1);
        MP3_TaoCode = sp.load(this, R.raw.taocode, 1);
        MP3_Buy0 = sp.load(this, R.raw.buy0, 1);
        MP3_RedPacket = sp.load(this, R.raw.redpacket, 1);
        sp.setOnLoadCompleteListener(new SoundPool.OnLoadCompleteListener() {
            @Override
            public void onLoadComplete(SoundPool soundPool, int sampleId, int status) {
                // 音频加载完成后的处理
                AudioManager audioManager = (AudioManager) getApplicationContext().getSystemService(Context.AUDIO_SERVICE);
                //int NoticeVolume= audioManager.getStreamVolume(AudioManager.STREAM_NOTIFICATION);
                //int NoticeMaxVolume= audioManager.getStreamMaxVolume(AudioManager.STREAM_NOTIFICATION);
                //int NoticeMinVolume= audioManager.getStreamMinVolume(AudioManager.STREAM_NOTIFICATION);
                audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeVolume, AudioManager.FLAG_PLAY_SOUND);
            }
        });
        //windowManager = (WindowManager) getSystemService(WINDOW_SERVICE);
        //layoutParams = new WindowManager.LayoutParams();
        //if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
        //    layoutParams.type = WindowManager.LayoutParams.TYPE_APPLICATION_OVERLAY;
        // } else {
        //     layoutParams.type = WindowManager.LayoutParams.TYPE_PHONE;
        //}
        //layoutParams.format = PixelFormat.TRANSLUCENT;
        //layoutParams.gravity = Gravity.LEFT | Gravity.TOP;
        //layoutParams.flags = WindowManager.LayoutParams.FLAG_NOT_TOUCH_MODAL | WindowManager.LayoutParams.FLAG_NOT_FOCUSABLE;
        // layoutParams.width = WindowManager.LayoutParams.MATCH_PARENT;
        // layoutParams.height = WindowManager.LayoutParams.MATCH_PARENT;
        // layoutParams.x = 300;
        // layoutParams.y = 300;
    }

    @Override
    public void onDestroy() {
        sp.unload(MP3_notice);
        sp.unload(MP3_mm);
        sp.unload(MP3_Ring);
        sp.unload(MP3_kuaidi);
        sp.unload(MP3_Dingding);
        sp.unload(MP3_TaoCode);
        sp.unload(MP3_Buy0);
        sp.unload(MP3_RedPacket);
        unregisterReceiver(messageReceiver);
        super.onDestroy();
    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        Log.i("KEVIN", "Service is started" + "-----");
        //
        //data = intent.getStringExtra("data");
        return super.onStartCommand(intent, flags, startId);
    }

    SoundPool sp;
    int MP3_notice;
    int MP3_mm;
    int MP3_Ring;
    int MP3_kuaidi;
    int MP3_Dingding;
    int MP3_TaoCode;
    int MP3_Buy0;
    int MP3_RedPacket;
    String Last_packageName = "";
    String Last_Title = "";
    String Last_Content = "";
    long Last_UpdateTime = 0;

    /**
     * 判断给定的设备名称是否已连接经典蓝牙
     *
     * @param BlueToothName 蓝牙设备名称
     * @return
     */
    public boolean isConnectClassicBT(String BlueToothName) {
        if (TextUtils.isEmpty(BlueToothName)) {
            return false;
        }
        final BluetoothAdapter bluetoothAdapter = BluetoothAdapter.getDefaultAdapter();
        Class<BluetoothAdapter> bluetoothAdapterClass = BluetoothAdapter.class;//得到BluetoothAdapter的Class对象
        try {
            //是否存在连接的蓝牙设备
            Method method = bluetoothAdapterClass.getDeclaredMethod("getConnectionState", (Class[]) null);
            //打开权限
            method.setAccessible(true);
            int state = (int) method.invoke(bluetoothAdapter, (Object[]) null);
            if (state == BluetoothAdapter.STATE_CONNECTED) {
                Log.d("test", "BluetoothAdapter.STATE_CONNECTED");
                if (ActivityCompat.checkSelfPermission(this, Manifest.permission.BLUETOOTH_CONNECT) != PackageManager.PERMISSION_GRANTED) {
                    // TODO: Consider calling
                    //    ActivityCompat#requestPermissions
                    // here to request the missing permissions, and then overriding
                    //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
                    //                                          int[] grantResults)
                    // to handle the case where the user grants the permission. See the documentation
                    // for ActivityCompat#requestPermissions for more details.
                    return false;
                }
                Set<BluetoothDevice> devices = bluetoothAdapter.getBondedDevices();
                Log.d("test", "devices:" + devices.size());
                for (BluetoothDevice device : devices) {
                    Method isConnectedMethod = BluetoothDevice.class.getDeclaredMethod("isConnected", (Class[]) null);
                    method.setAccessible(true);
                    boolean isConnected = (boolean) isConnectedMethod.invoke(device, (Object[]) null);
                    if (isConnected) {
                        {
                            return BlueToothName.contains(device.getName());
                        }
                    } else {
                        Log.d("test", device.getName() + " connect false(" + device.getAddress() + ")");
                    }
                }

            }
            return false;
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }
    /**
     * 播放声音
     * @param SoundId 声音id
     * @param loop 循环次数
     * @param DNDPlay 是否在免打扰时依旧播放
     */
    private void PlaySound(int SoundId,int loop,boolean DNDPlay)
    {
        float volume=1f;
        if(!DNDPlay) //如果该声音未开启免打扰时允许播放,则检查当前是否属于免打扰
        {
            Calendar c = Calendar.getInstance();
            //int year = c.get(Calendar.YEAR); // 获取当前年份
            //int month = c.get(Calendar.MONTH) + 1; // 获取当前月份
            //int day = c.get(Calendar.DAY_OF_MONTH); // 获取当日
            int dayOfWeek = c.get(Calendar.DAY_OF_WEEK); // 获取当前日期的星期,1 表示星期日、用 2 表示星期一
            int hour = c.get(Calendar.HOUR_OF_DAY); // 时
            int minute = c.get(Calendar.MINUTE); // 分
            if(hour>=23 || hour<7) {return; } //23点到早上7点,免打扰时间段
            AudioManager audioManager = (AudioManager) getApplicationContext().getSystemService(Context.AUDIO_SERVICE);
            NoticeVolume= audioManager.getStreamVolume(AudioManager.STREAM_NOTIFICATION);
            int NoticeMaxVolume= audioManager.getStreamMaxVolume(AudioManager.STREAM_NOTIFICATION);
            int NoticeMinVolume= audioManager.getStreamMinVolume(AudioManager.STREAM_NOTIFICATION);
            if(getWifiName().indexOf("当游")>=0) { //当连接到公司wifi
                if(hour==12 || (hour==13 && minute<=30))
                {
                    return;//是中午,则不播放声音
                }
                else {
                    volume=0.3f;//不是中午,音量降低
                }
                if(NoticeVolume==NoticeMinVolume) {
                    audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeMinVolume + Math.round((NoticeMaxVolume - NoticeMinVolume) * 1/(float)2), AudioManager.FLAG_PLAY_SOUND);
                }
            }
            else {
                if(NoticeVolume<(NoticeMinVolume+(NoticeMaxVolume-NoticeMinVolume)/2)) {
                    audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeMinVolume + Math.round((NoticeMaxVolume - NoticeMinVolume) * 3/(float)4), AudioManager.FLAG_PLAY_SOUND);
                }
            }
            //if(hour>=23 && hour<7) {return; }
        }
        if(isConnectClassicBT("CARKIT"))
        {
            return;
        }
        sp.play(SoundId, volume, volume,1,loop,1);
        //audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeVolume, AudioManager.FLAG_PLAY_SOUND);
        //audioManager.setStreamVolume(AudioManager.STREAM_NOTIFICATION, NoticeVolume, AudioManager.FLAG_VIBRATE);
    }
    private int NoticeVolume=0;
    //在进程中去寻找当前APP的信息，判断是否在前台运行
    private boolean isAppOnForeground(String packageName) {
        return NoticeService.CurPackageName.equals(packageName);
    }
    private boolean IsGameMode()
    {
        if(isAppOnForeground("com.tencent.tmgp.sgame"))
        {
            return true;
        }
        return gameMode;
        // 读取数据
        //return sharedPreferences.getBoolean("GameMode", false);
    }
    /**
     * 获取wifi名称(必须要有GPS定位权限)
     */
    private String getWifiName()
    {
        WifiManager wifiManager = (WifiManager) getApplicationContext().getSystemService(WIFI_SERVICE);
        WifiInfo wifiInfo = wifiManager.getConnectionInfo();
        return wifiInfo.getSSID();
    }
    private long LastDoorRingTime=0;
    private long MiHomeTipTime=0;
    @Override
    public void onNotificationPosted(StatusBarNotification sbn) {
        //        super.onNotificationPosted(sbn);
        try {
            Notification notice=sbn.getNotification();
            if(notice==null){return;}
            Bundle extras = notice.extras;
            String packageName=sbn.getPackageName();
            String Title="";
            String Content="";
            //有些通知不能解析出TEXT内容，这里做个信息能判断
            if (extras == null && notice.tickerText!=null) {
                Content=notice.tickerText.toString();
            }
            else
            {
                Title=extras.getString(Notification.EXTRA_TITLE);
                Content=extras.getString(Notification.EXTRA_TEXT);
            }
            if(Title==null){Title="";}
            if(Content==null){Content="";}
            if(Title.length()==0 && Content.length()==0){return;}
            boolean haveTip=false;//该消息是否需要提醒。
            Calendar c = Calendar.getInstance();
            long NowTime=c.getTime().getTime();
            if(packageName.equals(Last_packageName)
                    && Title.equals(Last_Title)
                    && Content.equals(Last_Content)
                    && Last_UpdateTime+6000>NowTime
            )
            {
                return;
            }
            if(packageName.equals("com.tencent.mm")) //如果是微信
            {
                //region 微信中有人提到自己
                String[] strArr = "鑫之风;大头;凤鑫;风鑫;封信;风兴;奉新;凤兴;阿香;凤新;鑫哥".split(";");
                boolean haveInfo=false;
                for (int i = 0; i < strArr.length; ++i){
                    if(Content.contains(strArr[i]))
                    {
                        if(!IsGameMode()) {
                            FloatView fv = new FloatView(this);
                            fv.showFloatingWindow(notice, Title, Content);
                        }
                        //showFloatingWindow(notice,Title,Content);
                        PlaySound(MP3_mm,0,false);
                        haveInfo=true;
                        haveTip=true;
                        break;
                    }
                }
                //endregion
                //region 0元购
                if(!haveInfo)
                {
                    if(Title.contains("球球") || Content.contains("球球")) {
                        String[] strArr2 = "球球独家;口令;拍下;http;拍第;体验;福利;一单;元抢;内部;复制打开;漏洞;好评;0元;抢到;免单;独家".split(";");
                        for (int i = 0; i < strArr2.length; ++i) {
                            if (Content.contains(strArr2[i])) {
                                if(!IsGameMode()) {
                                    FloatView fv = new FloatView(this);
                                    fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#FF0000"));
                                }
                                //showFloatingWindow(notice,Title,Content);
                                int hour = c.get(Calendar.HOUR_OF_DAY); // 时
                                if(getWifiName().indexOf("当游")<0) {
                                    PlaySound(MP3_Buy0, 0, false);
                                }
                                else {
                                    PlaySound(MP3_Dingding, 0, false);
                                }
                                haveTip=true;
                                break;
                            }
                        }
                    }
                }
                //endregion
                //region 淘口令
                if(!haveInfo)
                {
                    CharSequence[] strArr2 = "tb.cn;淘tao;/宝;t~bao;[右]tb[左]".split(";");
                    for (int i = 0; i < strArr2.length; ++i) {
                        if (Content.contains(strArr2[i])) {
                            if(!IsGameMode()) {
                                FloatView fv = new FloatView(this);
                                fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#FF0000"));
                            }
                            int hour = c.get(Calendar.HOUR_OF_DAY); // 时
                            if(getWifiName().indexOf("当游")<0) {
                                PlaySound(MP3_TaoCode, 0, false);
                            }
                            haveTip=true;
                            break;
                        }
                    }
                }
                //endregion
                //region 微信红包
                if(!haveInfo)
                {
                    if (Content.contains("[微信红包]")) {
                        if(!IsGameMode()) {
                            FloatView fv = new FloatView(this);
                            fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#FF0000"));
                        }
                        int hour = c.get(Calendar.HOUR_OF_DAY); // 时
                        if(getWifiName().indexOf("当游")<0) {
                            PlaySound(MP3_RedPacket, 0, false);
                        }
                        haveTip=true;
                    }
                }
                //endregion
            }
            else if(packageName.equals("com.xiaomi.smarthome")) //如果是米家app
            {
                //region 米家app处理方式
                if(Title.equals("GroupSummary") ||Content.equals("GroupSummary")){return;};
                if(Title.contains("你有一条新消息") ||Content.contains("你有一条新消息")){return;};
                if(Title.contains("与手表米家连接中") ||Content.contains("与手表米家连接中")){return;};
                if(Title.contains("设备状态") || Content.contains("设备状态")){return;};
                if(Title.contains("楼下有人按门铃") || Content.contains("楼下有人按门铃"))
                {
                    if(LastDoorRingTime+60000>=NowTime){return;} //如果1分钟内有新的门铃提醒,则自动忽略
                    LastDoorRingTime=c.getTime().getTime();
                    if(!IsGameMode()) {
                        FloatView fv = new FloatView(this);
                        fv.showFloatingWindow(notice,Title, Content, Color.parseColor("#02BD9D"));
                    }
                    if(MiHomeTipTime+5000<NowTime) {
                        MiHomeTipTime = c.getTime().getTime();
                        Vibrator  vibrator = (Vibrator) getSystemService(VIBRATOR_SERVICE);
                        vibrator.vibrate(new long[]{100,10,100,1000}, -1);
                        PlaySound(MP3_Ring, 1, false);
                    }
                    haveTip=true;
                }
                else
                {
                    if(!IsGameMode()) {
                        FloatView fv = new FloatView(this);
                        if (Title.equals("自动化通知") || Title.equals("智能通知")) {
                            fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#02BD9D"));
                        } else {
                            if (Title.length() >= Content.length()) {
                                fv.showFloatingWindow(notice, Content, Title, Color.parseColor("#02BD9D"));
                            } else {
                                fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#02BD9D"));
                            }
                        }
                    }
                    haveTip=true;
                    if(MiHomeTipTime+5000<NowTime) {
                        Vibrator  vibrator = (Vibrator) getSystemService(VIBRATOR_SERVICE);
                        vibrator.vibrate(new long[]{100,10,100,1000}, -1);
                        MiHomeTipTime = c.getTime().getTime();
                        PlaySound(MP3_Dingding, 0, false);
                    }
                }
                //endregion
            }
            else if(packageName.equals("com.android.mms")) //如果是短信
            {
                //region 短信中提取快递获取信息
                String[] strArr = "保安室;快递室;收发室;派送成功;代收;".split(";");
                for (int i = 0; i < strArr.length; ++i){
                    if(Title.contains(strArr[i]) || Content.contains(strArr[i]))
                    {
                        if(!IsGameMode()) {
                            FloatView fv = new FloatView(this);
                            fv.showFloatingWindow(notice, Title, Content);
                        }
                        PlaySound(MP3_kuaidi,0,false);
                        haveTip=true;
                        break;
                    }
                }
                //endregion
            }
            else if(packageName.equals("com.jingyao.easybike") //哈啰出行
                    || packageName.equals("com.sdu.didi.psnger") //滴滴出行
                    || packageName.equals("com.didapinche.booking")) //嘀嗒出行
            {
                if(Title.contains("正在运行")){return;}
                if(Content.contains("正在运行")){return;}
                if(Title.contains("哈啰顺风车运行中") || Content.contains("哈啰顺风车运行中")|| Content.contains("哈啰出行使用中")){return;}
                if(Content.contains("附近有一笔订单")){return;}
                if(Title.contains("顺风车出行中") || Content.contains("顺风车出行中") || Content.contains("行程安全保障") || Content.contains("行程录音中")){return;}
                if(Content.contains("您有一条消息")){return;}
                if(Content.contains("有一条新消息")){return;}
                if(Content.contains("您有新的消息")){return;}
                if(Content.contains("使用中")){return;}
                if(Content.contains("已隐藏敏感")){return;}
                if(Title.contains("天气提醒")){return;}
                if(packageName.equals("com.jingyao.easybike"))//哈啰出行
                {
                    if(!Title.contains("顺路"))
                    {
                        return;
                    }
                }
                if(packageName.equals("com.didapinche.booking"))//嘀嗒出行
                {
                    if(!Content.contains("顺路"))
                    {
                        return;
                    }
                    if(!Title.contains("新订单"))
                    {
                        return;
                    }
                }
                if(!IsGameMode()) {
                    //region 如果是顺风车线路
                    FloatView fv = new FloatView(this);
                    if (packageName.equals("com.jingyao.easybike")) {
                        fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#0391FF"));
                    } else if (packageName.equals("com.sdu.didi.psnger")) {
                        fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#F8934C"));
                    } else if (packageName.equals("com.didapinche.booking")) {
                        fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#FED051"));
                    } else {
                        fv.showFloatingWindow(notice, Title, Content);
                    }
                    haveTip = true;
                    PlaySound(MP3_Dingding, 0, false);
                    //endregion
                }
            }
            else if(packageName.equals("com.taobao.taobao")
                    || packageName.equals("com.jingdong.app.mall")
                    || packageName.equals("com.xunmeng.pinduoduo")) //如果是淘宝或京东或拼多多
            {
                //region 判断是否是物流信息
                String[] strArr = "签收;发货;派送;派件;".split(";");
                for (int i = 0; i < strArr.length; ++i){
                    if(Title.contains(strArr[i]) || Content.contains(strArr[i]))
                    {
                        if(!IsGameMode()) {
                            FloatView fv = new FloatView(this);
                            fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#FD5C02"));
                        }
                        PlaySound(MP3_Dingding,0,false);
                        haveTip=true;
                        break;
                    }
                }
                //endregion
            }
            else if(packageName.equals("com.dreame.smartlife")) //追觅
            {
                if(!IsGameMode()) {
                    FloatView fv = new FloatView(this);
                    fv.showFloatingWindow(notice, Title, Content, Color.parseColor("#020202"));
                }
                PlaySound(MP3_Dingding,0,false);
                haveTip=true;
                //endregion
            }
            //else {
            //    Toast.makeText(this,packageName+"->"+Title+"-"+Content, Toast.LENGTH_SHORT).show();
            //    sp.play(MP3_notice, 1f, 1.0f, 1, 0, 1);
            //}
            if(haveTip)
            {
                Last_packageName=packageName;
                Last_Title=Title;
                Last_Content=Content;
                Last_UpdateTime=NowTime;
            }
        } catch (Exception e) {
            Toast.makeText(this, "不可解析的通知->"+e.getMessage(), Toast.LENGTH_SHORT).show();
        }
    }
    private void showFloatingWindow(Notification notice, String Title, String Content) {
        if (Settings.canDrawOverlays(this)) {
            LayoutInflater layoutInflater = LayoutInflater.from(this);
            View displayView = layoutInflater.inflate(R.layout.float_tip, null);
            displayView.setOnTouchListener(new FloatingOnTouchListener());
            ImageView image=displayView.findViewById(R.id.IdIcon);
            image.setImageIcon(notice.getSmallIcon());
            image.setOnClickListener(v -> {
                //打开通知栏的intent，即打开对应的聊天界面
                PendingIntent pendingIntent = notice.contentIntent;
                try {
                    pendingIntent.send();
                    if (windowManager != null) windowManager.removeView(displayView);
                } catch (PendingIntent.CanceledException e) {
                    Toast.makeText(this, "打开出错->"+e.getMessage(), Toast.LENGTH_SHORT).show();
                    e.printStackTrace();
                }
            });
            //image.setOnTouchListener(new FloatingOnTouchListener());
            ImageView image_close=displayView.findViewById(R.id.IdClose);
            image_close.setImageResource(R.drawable.close);
            image_close.setOnClickListener(v -> {
                if (windowManager != null) windowManager.removeView(displayView);
            });
            TextView idTitle = displayView.findViewById(R.id.IdTitle);
            //idTitle.setOnTouchListener(new FloatingOnTouchListener());
            TextView idContent = displayView.findViewById(R.id.IdContent);
            TextView idPostTime = displayView.findViewById(R.id.IdPostTime);
            idTitle.setText(Title);
            idContent.setText(Content);
            SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy年MM月dd日 HH:mm:ss");// HH:mm:ss
            //获取当前时间
            Date date = new Date(System.currentTimeMillis());
            idPostTime.setText("时间:"+simpleDateFormat.format(date));
            //idContent.setOnTouchListener(new FloatingOnTouchListener());
            windowManager.addView(displayView, layoutParams);
        }
    }
    private class FloatingOnTouchListener implements View.OnTouchListener {
        private int x;
        private int y;

        @Override
        public boolean onTouch(View view, MotionEvent event) {
            switch (event.getAction()) {
                case MotionEvent.ACTION_DOWN:
                    x = (int) event.getRawX();
                    y = (int) event.getRawY();
                    break;
                case MotionEvent.ACTION_MOVE:
                    int nowX = (int) event.getRawX();
                    int nowY = (int) event.getRawY();
                    int movedX = nowX - x;
                    int movedY = nowY - y;
                    x = nowX;
                    y = nowY;
                    layoutParams.x = layoutParams.x + movedX;
                    layoutParams.y = layoutParams.y + movedY;
                    windowManager.updateViewLayout(view, layoutParams);
                    break;
                default:
                    break;
            }
            return false;
        }
    }
}
